/*----- PROTECTED REGION ID(TestSpectrumWritingClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        TestSpectrumWritingClass.h
//
// description : Include for the TestSpectrumWriting root class.
//               This class is the singleton class for
//                the TestSpectrumWriting device class.
//               It contains all properties and methods which the
//               TestSpectrumWriting requires only once e.g. the commands.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
// Copyright (C): 2024
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef TestSpectrumWritingClass_H
#define TestSpectrumWritingClass_H

#include <tango.h>
#include "TestSpectrumWriting.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWritingClass.h


namespace TestSpectrumWriting_ns
{
/*----- PROTECTED REGION ID(TestSpectrumWritingClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	TestSpectrumWritingClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute RWFloatSpectrum class definition
class RWFloatSpectrumAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for RWFloatSpectrum attribute
	constexpr static long X_DATA_SIZE = 10;
	RWFloatSpectrumAttrib():SpectrumAttr("RWFloatSpectrum",
			Tango::DEV_FLOAT, Tango::READ_WRITE, RWFloatSpectrumAttrib::X_DATA_SIZE) {};
	~RWFloatSpectrumAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<TestSpectrumWriting *>(dev))->read_RWFloatSpectrum(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<TestSpectrumWriting *>(dev))->write_RWFloatSpectrum(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<TestSpectrumWriting *>(dev))->is_RWFloatSpectrum_allowed(ty);}
};


/**
 *	The TestSpectrumWritingClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  TestSpectrumWritingClass : public Tango::DeviceClass
#else
class TestSpectrumWritingClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(TestSpectrumWritingClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	TestSpectrumWritingClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static TestSpectrumWritingClass *init(const char *);
		static TestSpectrumWritingClass *instance();
		~TestSpectrumWritingClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		TestSpectrumWritingClass(std::string &);
		static TestSpectrumWritingClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	TestSpectrumWriting_H
